
// LA PALETTE

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Palette {
  int x,y; // position
  int L=9,H=9; // largeur hauteur des paves
  int S=2;
  float zoom; // taux de zoom
  Pave[] paves={new PaveDroit(),new PaveBiais(),new PaveArc45(),new PaveAiguilleDroite(),new PaveAiguilleBiaise(),
                new PaveAiguilleSymetrique(),
                new PaveTJD(),new PaveTJS(),new PaveAiguilleTriple(),
                new PaveCroisementDroitDroit(),new PaveCroisementDroitBiais(),new PaveCroisementBiaisBiais()};
  int nb=paves.length;
  Pave pave; // le pave selectionne

  Palette(int x,int y,float z) {this.x=x; this.y=y; zoom=z; } // constructeur 

  void dessiner() { int i; Pave p;
    pushMatrix();
    translate(x,y); 
    fill(0); textSize(5*zoom);// noir
    if (pave!=null) text(pave.affichage(),0,20*zoom);
    noFill(); stroke(0); for (i=0; i<paves.length; i++)  { rect(i*(9+S)*zoom,0,9*zoom,9*zoom); }
    scale(zoom); // zoom
    for (i=0; i<paves.length; i++)  {
      p=paves[i];
      pushMatrix();
      translate(i*(9+S),0); 
      p.dessiner();
      popMatrix();
    }
    popMatrix();
  }

  void clicked(float mx,float my) { int i; 
    if (mx<x || my<y || mx>x+(nb-1)*S*zoom+nb*L*zoom || my>y+H*zoom) return;
    for (i=0; i<nb; i++) {
      if (!(mx<x+(i*(L+S))*zoom || mx>x+(i*(L+S)+L)*zoom)) { 
       pave=paves[i]; // bon pave
       if ( keyPressed && keyCode==ALT) { 
         if (mouseButton==RIGHT) pave.manoeuvrer(true); else pave.manoeuvrer(false); 
       } else {
         if (mouseButton==LEFT) pave.rotation();
         if (mouseButton==RIGHT) pave.symetrie();
       }
       //println(pave.affichage()); 
       clipboard.setContents(new java.awt.datatransfer.StringSelection(pave.affichage()),null);
       return; 
      }
    }
  }
  
  void moved(float mx,float my) { int i; 
    if (mx<x || my<y || mx>x+(nb-1)*S*zoom+nb*L*zoom || my>y+H*zoom) return;
    for (i=0; i<nb; i++) {
      if (!(mx<x+(i*(L+S))*zoom || mx>x+(i*(L+S)+L)*zoom)) { 
       pave=paves[i]; // bon pave
       //println(pave.affichage()); 
       clipboard.setContents(new java.awt.datatransfer.StringSelection(pave.affichage()),null);
       return; 
      }
    }
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////